#!/usr/bin/env python3

'''
SPDX-License-Identifier: GPL-3.0-or-later
Copyright (c) 2020, Elphel, Inc.

Author:      Oleg Dzhimiev <oleg@elphel.com>
Description: Converts jp4 images to jpeg for preview
             Scans all images in src-dir and puts results to dst-dir
'''

from jp4_composite import JP4_C
#import cv2
import numpy as np
import sys
from PIL import Image, ImageOps
import os

try:
  src = sys.argv[1]
except IndexError:
  src = "."

try:
  dst = sys.argv[2]
except IndexError:
  dst = "."

lst = os.listdir(src)
lst.sort()

for f in lst:

  path = os.path.join(src,f)
  if os.path.isfile(path):
    print("Converting "+f)
    img = JP4_C(path)
    #print(img.exif.toString())
    #print(img.exif.data['Model'])
    img.deblock()
    img.demosaic_bilinear()
    img_arr = img.saturation()
    im = Image.fromarray(img_arr.astype(np.uint8))
    im.save(os.path.join(dst,img.basename+"_"+str(img.subnames)+".jpeg"))

    #subs = img.extract_subframes()
    #for i in range(len(subs)):
      #subs[i].save(os.path.join("../res",img.basename+"_"+str(img.subnames[i])+".png"))
    #  subs[i].save(os.path.join(dst,img.basename+"_"+str(img.subnames[i])+".jpeg"))
